<template>
  <div class="modal_4">
    <div class="modal" v-bind:class="{ active: isActive }" id="modal-id">
      <span class="modal-overlay"></span>
      <a href="#close" class="modal-overlay" aria-label="Close"></a>
      <div class="modal-container inactive" id="modalContainer">
        <div class="modal-header inactive">
         <div class="heading1" >
            <a v-on:click="close" class="btn btn-clear float-right close-btn" aria-label="Close"></a>
            <div class="modal-title h5"><span class="package_tag_header">{{this.clickedpackage.tag}}</span> Package Template</div>
          </div>
        </div>
        <div class="modal-body inactive">
          <div class="modal_content" id="content">
            <div class="container" v-if="showView">
              <div class="columns">
                <div class="column col-12 package-section top-actions">
                  <div class="toast toast-success" v-if="alertSuccess">
                    <button class="btn btn-clear float-right" @click="closeAlert"></button>
                    {{ alertMessage }}
                  </div>
                  <div class="toast toast-error" v-if="alertError" @click="closeAlert">
                    <button class="btn btn-clear float-right"></button>
                    {{ alertMessage }}
                  </div>
                </div>
                <div class="column package-section top-actions">
                  <p><strong>Package Name:</strong> {{ clickedpackage.tag }}<br>
                  <strong>Package Description:</strong> {{ clickedpackage.description }}</p>
                </div>
              </div>
              <div class="columns">
                <div class="column package-section top-actions">
                  <table class="table table-striped table-hover">
                    <thead>
                      <tr>
                        <th>Type</th>
                        <th>Rate</th>
                        <th>Frequency</th>
                        <th>Basis</th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr v-for="earning in earnings" :key="earning.id" >
                        <td>{{ earning.type }}</td>
                        <td>{{ earning.rate }}</td>
                        <td>{{ earning.frequency }}</td>
                        <td>{{ earning.basis }}</td>
                      </tr>
                    </tbody>
                  </table>
                </div>
              </div>
              <div class="columns">
                <div class="column package-section top-actions">
                  <span class="newBtn" @click="deletePackage"><img src="/images/icons/delete.svg" alt="delete icon" class=""/><span class="icon_label">DELETE</span></span>
                  <span class="float-right newBtn" @click="editing"><img src="/images/icons/show_page_edit.svg" alt="edit icon" class=""/><span class="icon_label">EDIT</span></span>
                </div>
              </div>
            </div>

            <div class="container" v-if="editView">
              <div class="columns">
                <div class="column col-6 package-section top-actions">
                  <div class="form-group">
                    <label class="form-label" for="packageName">Package Name</label>
                    <input v-model="clickedpackage.tag" class="form-input" type="text" id="input-example-1">
                    <div class="errorStyle" v-if="errorTag"><small>Can't be blank</small></div>
                  </div>
                  <div class="form-group">
                    <label class="form-label" for="packageName">Package Description</label>
                    <input v-model="clickedpackage.description" class="form-input" type="text" id="input-example-1">
                    <div class="errorStyle" v-if="errorDescription"><small>Can't be blank</small></div>
                  </div>
                </div>
              </div>

              <!-- <div class="columns">
                <div class="column package-section top-actions">
                  <div class="float-right">
                    <button class="btn btn-package" @click="addRow">Add Earnings</button>
                  </div>
                </div>
              </div> -->
              <div class="columns">
                <div class="column package-section top-actions">
                  <table class="table">
                    <thead>
                      <tr>
                        <th>Type</th>
                        <th>Frequency</th>
                        <th>Basis</th>
                        <th>Rate</th>
                        <th></th>
                      </tr>
                    </thead>
                    <tbody ref="editable_table">
                      <tr v-for="(e, index) in earnings" v-bind:key="index">
                        <td>
                          <span v-if="e.is_editable">
                            <select class="form-select" v-model="earning.type">
                              <option value="">Choose type</option>
                              <option v-for="type in types" v-bind:key="type">{{ type }}</option>
                            </select>
                          </span>
                          <span v-else>{{ e.type }}</span>
                        </td>
                        <td>
                          <span v-if="e.is_editable">
                            <select class="form-select" v-model="earning.frequency">
                              <option v-for="frequency in frequencies" v-bind:key="frequency">{{frequency}}</option>
                            </select>
                          </span>
                          <span v-else>{{ e.frequency }}</span>
                        </td>
                        <td>
                          <span v-if="e.is_editable">
                            <select class="form-select" v-model="earning.basis">
                              <option value="">Choose basis</option>
                              <option v-for="base in basis" v-bind:key="base">{{ base }}</option>
                            </select>
                          </span>
                          <span v-else>{{ e.basis }}</span>
                        </td>
                        <td>
                          <span v-if="e.is_editable">
                            <input class="form-input" type="number" v-model="earning.rate"/>
                          </span>
                          <span v-else>{{ e.rate }}</span>
                        </td>
                        <td>
                          <span v-if="e.is_editable">
                            <span @click="addItem(index)"><img src="/images/icons/content-save.svg" alt="Save icon" class="table_icon"/></span> |
                            <span @click="cancelItem(index)"><img src="/images/icons/close-circle.svg" alt="Cancel icon" class="table_icon"/></span>
                          </span>
                          <div v-else>
                            <span @click="editRow(index)"><img src="/images/icons/pencil-outline.svg" alt="Edit icon" class="table_icon"/></span> |
                            <span @click="deleteRow(index)"><img src="/images/icons/delete-outline.svg" alt="Delete icon" class="table_icon"/></span>
                          </div>
                        </td>
                      </tr>
                    </tbody>
                  </table>
                </div>
              </div>
              <div class="columns">
                <div class="column package-section top-actions">
                  <span class="newBtn" @click="editCancel"><img src="/images/icons/show_page_cancel.svg" alt="cancel icon" class=""/><span class="icon_label">CANCEL</span></span>
                  <span class="float-right">
                    <span class="newBtn mr-1" @click="addRow"><img src="/images/icons/show_page_add.svg" alt="edit icon" class=""/><span class="icon_label">ADD</span></span>

                    <span class="newBtn" @click="update"><img src="/images/icons/update.svg" alt="edit icon" class=""/><span class="icon_label">UPDATE</span></span>
                  </span>
                </div>
              </div>
            </div>

          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import axios from 'axios'
export default {
  name: "modal_4",
  props: ["clickedpackage"],
  components: {
    
  },
  data() {
    return {
      show_modal: false,
      basis: ["Daily", "Hourly", "Monthly"],  
      isActive: true,
      id: parseInt(this.clickedpackage.id),
      earnings: [],
      frequencies: ["Daily", "Weekly", "Monthly", "Fortnightly"],
      packages: [],
      types: ["Salary", "Housing", "Transport"],
      earning: {
          "type": "Salary",
          "frequency": "Daily",
          "basis": "Monthly",
          "rate": 0
      },
      editView: false,
      showView: true,
      alertError: false,
      alertSuccess: false,
      alertMessage: "",
      errorTag: false,
      errorDescription: false
    }
  },

  methods:{
    close(event) {
       this.$emit("close", this.display_show_modal); 
     
    },
    editing() {
      this.editView = true
      this.showView = false
    },
    editCancel(){
      this.editView = false
      this.showView = true
    },
    closeAlert() {
      if(this.alertSuccess === true) {
        this.alertSuccess = false
      } else if (this.alertError === true) {
        this.alertError = false
      }
    },
    deletePackage() {
      axios.delete('/api/packages/' + this.clickedpackage.id)
      .then(response => {
        console.log("package deleted")
        
      })

      window.location.reload();

    },
    update() {
      var params =
        {"package":  
          {
            "tag": this.clickedpackage.tag,
            "description": this.clickedpackage.description,
            "id": this.clickedpackage.id
          }
        }        
      var url = '/api/packages/'+ this.clickedpackage.id
      let csrf = document.querySelector("meta[name='csrf-token']").getAttribute("content");
      if(this.clickedpackage.tag && this.clickedpackage.description != "") {
        axios.put(url, params, { headers: {'Content-Type': 'application/json', 'x-csrf-token': csrf}})
        .then((response) => {
          console.log("package updated")
          
        });

        var urls = "/api/earnings/upsert";
        var paramss = {package: this.clickedpackage.id, earning: this.earnings};
        
        axios.post(urls, paramss, { headers: {'Content-Type': 'application/json', 'x-csrf-token': csrf}})
        .then(response => {
            console.log("working")

            window.location.assign("/settings/packages")

            this.alertSuccess = true
            this.alertMessage = "Package updated successfully"
            setTimeout(function(){this.alertSuccess = false; }, 5000);
        })
     
      } else {
        
        if(this.clickedpackage.tag === "") {
          this.errorTag = true
        }
        if (this.clickedpackage.description === ""){
          this.errorDescription = true
        }
        this.alertMessage = "Error! Some fields are not filled properly"
        this.alertError = true
        setTimeout(function(){self.alertError = false; }, 5000);
      }
    },
    addItem(index) {
      this.earnings[index].type = this.earning.type
      this.earnings[index].frequency = this.earning.frequency
      this.earnings[index].basis = this.earning.basis
      this.earnings[index].rate = this.earning.rate
      this.earnings[index].is_editable = false
      
      this.resetEarning()
    },
    addRow() {
      this.earnings.push({
        "type": "Salary",
        "frequency": "Daily",
        "basis": "Monthly",
        "rate": 0,
        "is_editable": true
      })
    },
    addType(event) {
      console.log(event.target.value)
    },
    cancelItem(index) {
      this.$set(this.earnings[index], 'is_editable', false)
    },
    editRow(index) {
      this.$set(this.earnings[index], 'is_editable', true)
      this.earning.type = this.earnings[index].type,
      this.earning.frequency = this.earnings[index].frequency,
      this.earning.basis = this.earnings[index].basis,
      this.earning.rate = this.earnings[index].rate
    },
    resetEarning() {
      this.earning.type = "Salary",
      this.earning.frequency = "Monthly",
      this.earning.basis = "Monthly",
      this.earning.rate = 0
    },
    deleteRow(index) {
      this.earnings.splice(index, 1)
      console.log(this.earnings)
    },
    exportData() {
    const axios = require("axios");
    var url = "/api/earnings/upsert";
    var params = {package:this.id, earning:this.earnings};
    let csrf = document.querySelector("meta[name='csrf-token']").getAttribute("content");
    axios.post(url, params,  { headers: {'Content-Type': 'application/json', 'x-csrf-token': csrf}})
    .then(response => {
           
    });
    }

  }, 
  cancelItem(index) { }, 

  mounted(){
    var self = this;
      axios.get("/api/package_earnings/"+ this.clickedpackage.id).then(function(response){
        self.earnings = response.data
      })
      .catch(function (error) {
        console.log(error)
      })
  }  
}
</script>
<style scoped>
.mr-1 {
  margin-right: 1rem !important;
}
.mt-1 {
  margin-top: 3rem !important;
}
</style>